#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "UIFriends.hpp"
#include "OrganizationTree.h"
#include "MainMenuControler.h"
#include "FavoriteController.h"
#include "WorkGroupController.h"
#include "CallHistoryDlg.h"
#include "AutoTextConfigDlg.h"
#include "MenuXP.h"
#include "RecentContacts.h"
#include "RecentChatListManager.h"
#include "UserImageActor.h"
#include "TreeDrop.h"
#include "AddChatWnd.h"
#include "InfoBannerWnd.h"
class CSearchWnd;
class CChatSearchWnd;
class CSmsSearchWnd;
class CSMSSendWnd;
class CChatDlg;
//class CAddChatWnd;

using namespace DuiLib;

enum eMenu_POPUP_TYPE
{
	TREE_POPUP_MENU = 1,
	//WORKGROUP_TREE_MENU = 2,
	LIST_POPUP_MENU = 3,
	CHAT_POPUP_MENU = 8,
};

#define BOOKMARK_ADD	0
#define BOOKMARK_DEL	1
#define FAVORITE_SELECT		(_T("btn_main_bookmark_icon_sel.png"))
#define FAVORITE_NORMAL		(_T("btn_main_bookmark_icon_nor.png"))

typedef enum _E_MENUTAB
{
    eSelectUnknown = -1,
	eOrganizationTab = 0,
	eFavoriteTab,
	eRecentChatTab,
	eActiveGroup
}EMENUTAB;

#define TID_NOTICE_ROLLING			0x1100
#define NOTICE_ROLLING_INTERVAL  	10000

typedef std::map<int, int>	GROUP_MEMU_LIST;



//-----------------------------------------------------------------------------
// by cscho
// New UI
#define ID_INFOITEM_NOTE			(0xB001)
#define ID_INFOITEM_MAIL			(0xB002)
#define ID_INFOITEM_VOC				(0xB003)
#define ID_INFOITEM_SIGN			(0xB004)
#define ID_INFOITEM_SURVEY			(0xB005)
#define ID_INFOITEM_WORKORG			(0xB006)
#define ID_INFOITEM_IN				(0xB007)
#define ID_INFOITEM_SAM				(0xB008)
#define ID_INFOITEM_CHAT			(0xB009)
#include "InfoItemWnd.h"

#define ID_INFO_VOLUME				(0xA001)
#include "InfoVolumeWnd.h"

#define ID_INFO_ABOUTME				(0xD001)
#include "InfoAboutMeWnd.h"
#define ID_IPT_ABOUTME				(0xDEE3)

#define ID_INFO_SEARCH				(0xE001)
#include "InfoSearchWnd.h"

#define DEF_OUTLINK_HEIGHT			(27)
#define DEF_SEARCH_BAR_GAP_Y		(5)
#define DEF_SEARCH_BAR_GAP_X_L		(10)
#define DEF_SEARCH_BAR_GAP_X_R		(32)
#define DEF_BANNER_HEIGHT			(60)
#define DEF_LEGACY_BTN_WIDTH		(46)
#define DEF_LEGACY_BTN_HEIGHT		(32)

#define ID_INFO_BANNER				(0xF001)
#include "InfoBannerWnd.h"

#define ID_INFO_OUTLINK				(0xC001)

//-----------------------------------------------------------------------------

class CNeMessengerDlg;
class CLayeredDlg;
//class CBannerNoticeWnd;
namespace DuiLib{

	class BannerBoard:public CVerticalLayoutUI
	{
		public:

		BannerBoard(CPaintManagerUI& paint_manager, HWND hWnd);
		~BannerBoard();	
		void		DoEvent(TEventUI& event);
		void        SetBannerController(CInfoBannerController* pController){m_pBannerCtrller = pController;};

	public:
		CPaintManagerUI& paint_manager_;
	private:
		HWND		 m_hParent;
		CInfoBannerController* m_pBannerCtrller;

	};

	class ButtonBoard:public CHorizontalLayoutUI
	{
	public:

		ButtonBoard(CPaintManagerUI& paint_manager, HWND hWnd);
		~ButtonBoard();	
		void		DoEvent(TEventUI& event);

	public:
		CPaintManagerUI& paint_manager_;
		HWND		 m_hParent;
	};
}


typedef enum _E_DRAG_DROP_TYPE
{
	eList = 0,
	eMenu
}EDDTYPE;


class MainFrame : public WindowImplBase, 
	public ITreeDropOwner, 
	private IGTWASActorEvent ,
	private IGTMessengerActorEvent,
	public IUserImageActorObserver
{
    DUI_DECLARE_MESSAGE_MAP()
    DUI_DECLARE_CUSTOM_MSG_MAP()
public:

	MainFrame(CNeMessengerDlg* pNeMessageDlg);
	~MainFrame();

	enum ePOPUP_TYPE
	{
		TREE_POPUP_MENU = 1,
		LIST_POPUP_MENU = 3
	};
public:
	void LoadSkin();
	LPCTSTR GetWindowClassName() const;	
	virtual void OnFinalMessage(HWND hWnd);
	virtual void InitWindow();
	virtual LRESULT ResponseDefaultKeyEvent(WPARAM wParam);
	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual UILIB_RESOURCETYPE GetResourceType() const;
	virtual CControlUI* CreateControl(LPCTSTR pstrClass);
	virtual LRESULT OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LPCTSTR GetResourceID() const;
	virtual LRESULT OnNcLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    //IUserImageActorObserver
	virtual void OnUserImageActor_OnResponseUserImageInfo(CString strUserId);

	int	GetSelectedOnlineFavoritesCount();
	int	GetSelectedFavoritesCount(){ return m_favoriteController.GetSelectedFavoritesCount(); }
	DWORD GetBkColor();
	void SetBkColor(DWORD dwBackColor);
	void InitControls();
	void LoadTooltip();
	void SetToolTip(LPCTSTR lpszCtrlName,LPCTSTR lpszVal);
	void InitFavoriteList() 
	{
		m_favoriteController.InitFavoriteList574();
	}
	void InitFavoriteListGroup(){

		m_favoriteController.CreateAllGroupItem574();
	}
	void InitFavoriteListBuddy(){
		m_favoriteController.CreateAllBuddyItem574();
	}

	void DeleteBuddy(LPCWSTR strUserId);
	void AddBuddy(const IGTBuddyUser* pUser);
	void DeleteBuddy(LPCWSTR strUserId, int nGroupId);
	void MoveBuddy(int nFromGroupID, const IGTBuddyUser* pUser);
	void UpdateStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID);
	void AddGroup(const IGTBuddyGroup* pGroup, bool bEditLabel = false);
	void UpdateGroupName(const IGTBuddyGroup* pGroup);
	void EditLableOn(const IGTBuddyGroup * pGroup = NULL);
	void UpdateInfoAboutMeStatus(GTUserStatusType gtStatus);
	GTUserStatusType GetMyStatus();
	void UpdateInfoAboutMeNickName(CString strNickName);
	void SetEditNickName(BOOL bEdit);
	void UpdateInfoVolume(UINT nTotalUsedCapa, UINT nLimitedCapa);
	void DeleteGroup(int nGroupID);
	void RedrawGroup();
	void FavoriteGroupResort();
	void SetCurChatSearchWnd(CChatSearchWnd *pSearchWnd);
	void SetCurSmsSearchWnd(CSmsSearchWnd *pSearchWnd);
	void UpdateOrganizationList(const std::vector<GT_ORG_GROUP_DATA>& list);
	void UpdateOrganizationMember(const std::vector<ORG_MEMBER_DATA> &memberVector);
	CString GetImageFromStatus( GTUserStatusType eUserStatus, BOOL bCombieMobile = TRUE,BOOL bVacation = FALSE);
	void LoadOrgMemberImage(LPCWSTR strUserID);
	void LoadRoomListImage(LPCWSTR strUserID);
	void LoadFavoriteImage(LPCWSTR strUserID);
	void LoadSearchMemberImage(LPCWSTR strUserID);
	void LoadChatSearchMemberImage(LPCWSTR strUserID);
	void LoadSmsSearchMemberImage(LPCWSTR strUserID);
	void UpdateMemberStatus(LPCWSTR strUserID);
	void UpdateMemberIPTStatus(LPCWSTR strUserId);
	void ChangeMyStatus(GTUserStatusType eMyStatus);
	void UpdateSearchWndMember(const std::vector<ORG_MEMBER_DATA> &memberVector, MemberSearchAction action);
	void MakeTreeChildNode(COrganizationTreeUI *pTree, Node* pParentNode, std::multimap<CString, CString> &parentChildMap, std::map<CString, CString> &groupNameMap);
	bool IsWindow();
	int	GetTridID() const{ return 0; }
	CBuddyTreeCtrl* GetBuddyList(){return m_pBuddyList;}

	void UpdateItemImage(LPCTSTR strID);
	void UpdataAllBuddyImage();
	BOOL IsFocuseOnSearchEdit();
	void OnSearchUser();
	void ReloadRecentChatRoomList();
	void CloseSearchWnd();
	void ShowNoUserInRecentChatList();
	BOOL IsShowMainSearchWnd();
	CSearchWnd * GetMainSearchWnd();
	void SetRequestSearch(CString strSearch, MemberSearchAction eSearchAction);

	void CloseAutoTextDlg();
	void CloseCallHistoryDlg();
	void OpenChatHistoryDlg(CString UserID);

	void StartNoticeList(const std::vector<NE_NOTICE_DATA> &vecNoticeList);
	void SetBannerList(const std::vector<NE_BANNER_DATA> &vecBannerList);
	void SetInfoItemCount(NTHanatourCountType eType, int nCount, CString strURL);
	void RedrawOutlink();
	void SetInfoItemNoteItemCount(int nCount);
	void SetInfoItemMailItemCount(int nCount);
	void SetSelectItems(vector<Node*>& vecSelectItems);
	void PopupMenuView(CPoint pt, int nMain,int nSub);
	void SetCurSelCtrl(Node *pNode);
	BOOL IsSelectMyself();
	void MakeFavoriteMenu(CMenu* menu, int nSub);
	int GetSelectOnlineUserCount();
	void SetUserAuth();
	BOOL HasAuth(DWORD nAuth);
	CRect GetSearchWndRect();
	void SetTimer(UINT nTimerID, UINT uElapse);
    //void SetTimer( int nId, int param2, void* param3 );
    void KillTimer( int nId );
	void SetBannerControl(CString);

    BOOL IsAllIdsInBuddyGroup(CStringList& selectedIdList, int nGroupID);

	BOOL IsGroupSelected() const{ return m_favoriteController.IsGroupSelected(); }
	BYTE GetDND();
	void SetDND( BYTE nStatus );
	BYTE GetForwardingStatus();
	void SetForwardingStatus( BYTE nForwarding );
	BOOL SetBookmark(CString strUserID, int nOpType=0);
	void OnCreateFavoriteGroup(int nID);
	void OnAddFavorite(int nID);
	void UpdateUnReadMessage(BOOL bAdd, int nRoomId );
	void CheckCloseProfileWindow();
	BOOL IsSelectFavoriteBtn(CButtonUI *pBtn);
	void OnBtnFavoriteDelete(CString strUserID);
	void OnBtnFavoriteAdd(CPoint pt, Node* pNode);
	void OnBtnFavorite(CPoint pt, CButtonUI* pBtnFavorite);
public:
	

	//Drag callback
	virtual CWnd* GetCWnd();

	virtual	DROPEFFECT	OnDragEnter(CWnd* pWnd, COleDataObject*  pDataObject,
		DWORD dwKeyState, CPoint point);
	virtual DROPEFFECT	OnDragOver(CWnd* pWnd , COleDataObject*  pDataObject,
		DWORD dwKeyState, CPoint point);

	virtual DROPEFFECT OnDragScroll(CWnd* pWnd, DWORD dwKeyState, CPoint point);

	virtual BOOL		OnDrop(CWnd* pWnd, COleDataObject* pDataObject,
		DROPEFFECT dropEffect, CPoint point);
	virtual void		OnDragLeave();
	virtual SCODE		GiveFeedback(DROPEFFECT dropEffect );

	void OnBnClickedTopmenuButton(CControlUI* menubtn);
	void CommandMessageRouter(int nId);

	//For NTALKCL-1075: Hanatour : IN/SAM button on Main Window

	BOOL OnCommandHanaBtn(UINT CtrlID);
private:
	static void CALLBACK _OnStatusCallBack(HINTERNET hInternet, DWORD_PTR dwContext, DWORD dwInternetStatus, LPVOID lpvStatusInformation, DWORD dwStatusInformationLength);

	void DownloadPicture(CString strURL);
	void DownloadThread();
	void CloseAllInternetHandle();
	void OnUserImageUpdated(CString strUserId);
	void MainFrame::InitMyProfile(void);
    void KillAllTimer();
    void SetAllTimer();

protected:	
    //refactor from MainFrame::_OnCommandMenuChat, and can use in SMS and other place
    int _GetSelectedMembers(std::vector<NE_MEMBER_DATA>& rSelectedMembers, BOOL bJustOnline = TRUE, BOOL bSkipSelf = TRUE);

	void OnNotifyCtrlKillFocus(TNotifyUI& msg);
	//void OnNotifyCtrlClick(TNotifyUI& msg);

    void _OnCtrlBtnInfoMeClick(TNotifyUI& msg);
    void _OnCtrlBtnIptStatusClick(TNotifyUI& msg);
    void _OnCtrlBtnFavoriteClick(TNotifyUI& msg);
    void _OnCtrlCloseBannerClick(TNotifyUI& msg);
    void _OnCtrlBtnCloseClick(TNotifyUI& msg);
    void _OnCtrlBtnMinClick(TNotifyUI& msg);
    void _OnCtrlBtnMaxClick(TNotifyUI& msg);
    void _OnCtrlBtnRestoreClick(TNotifyUI& msg);
    void _OnCtrlBtnMenuClick(TNotifyUI& msg);

	void _OnMenuOptionChatWebClick(TNotifyUI& msg); //chat history
	void _OnMenuOptionMailClick(TNotifyUI& msg);  // mail
    void _OnMenuOptionMemoClick(TNotifyUI& msg);  //memo
	void _OnMenuOptionSignClick(TNotifyUI& msg); //sign
	void _OnMenuOptionVOCClick(TNotifyUI& msg); //VOC
	void _OnMenuOptionSurveyClick(TNotifyUI& msg);  // survey
	void _OnMenuOptionINClick(TNotifyUI& msg);  //IN
	void _OnMenuOptionSAMClick(TNotifyUI& msg); //SAM
    
	void _OnMenuArrowUp(TNotifyUI& msg);
	void _OnMenuArrowDown(TNotifyUI& msg);
    void _OnCtrlBtnOrgPopClick(TNotifyUI& msg);
    void _OnCtrlBtnOrgIptClick(TNotifyUI& msg);
    void _OnCtrlTabBookmarkClick(TNotifyUI& msg);
    void _OnCtrSearchLabelClick(TNotifyUI& msg);
    void _OnCtrlSearchBtnClick(TNotifyUI& msg);
    void _OnCtrlSearchCancelClick(TNotifyUI& msg);
    void _OnCtrlHideLeftMainPannelClick(TNotifyUI& msg);
    void _OnCtrlShowLeftMainPannelClick(TNotifyUI& msg);
    void _OnCtrlChangeBkSkinClick(TNotifyUI& msg);
    void _OnCtrlChangeColorSkinClick(TNotifyUI& msg);
    void _OnCtrlStatusBtnClick(TNotifyUI& msg);
	void _OnCtrlButtonBoardClick(TNotifyUI& msg);

	void OnNotifyTabSelectChange(TNotifyUI& msg);
	void OnNotifyItemClick(TNotifyUI& msg);
	void OnNotifyItemDoubleClick(TNotifyUI& msg);
	void OnNotifyItemDrag(TNotifyUI& msg);
	void OnNotifyMainMenuDrag(TNotifyUI& msg);
	void OnNotifyItemEnter(TNotifyUI& msg);
	void OnNotifyItemEsc(TNotifyUI& msg);
	void OnNotifySetCurSor(TNotifyUI& msg);
	void OnPrepare(TNotifyUI& msg);
	void OnExit(TNotifyUI& msg);
	void OnNotifyTimer(TNotifyUI& msg);
	void OnDragStart(_E_MENUTAB DragType = eFavoriteTab);
	vector<CString> GetSelectedItemNameVector(_E_MENUTAB DragType);

	BYTE m_nForwardingStatus;
	BYTE m_nDndStatus;

public:
	NTIPTStatusType GetMemberIPTStatus(LPCWSTR strUserID);
	void MakeIPTMenu( NTIPTStatusType iptMyStatus, NTIPTStatusType iptStatusOfBuddy, const NE_MEMBER_DATA* pMembereData, CMenu* pPopup );
	void OnMenuIPT(const NE_MEMBER_DATA* pMembereData, WPARAM wParam);
	void CallToIPT(NE_MEMBER_DATA userData, CString strTel);
	void UpdateInfoAboutIPTStatus();
	BOOL MakeAboutIPTSatusPopupMenu( CMenu* pMenu );
	void LoadAboutIPTStatusPopup( CPoint pt );
	CImageList* CreateDragImageEx(vector<CString> vecSelectedName);
	CImageList* CreateDragGroupImageEx();

	void ReleaseChatRoomList();
	void GetSelectedOnlineFavorites( std::vector<const IGTBuddyUser *> buddyVector );
	void GetSelectedBuddyItems( std::vector<const IGTBuddyUser *>& buddyVector );
	void GetSelectedGroupItems( std::vector<const IGTBuddyGroup *>& GroupVector );

	void RequestDeleteBuddy();
	void RequestAddGroup();
	void RequestDeleteGroup();
	CString GetLanguage();
	CString MainFrame::GetUserID_Base64( CString UserID );
	void ImportGroup();
	void MenuCopyBuddy( UINT nCmdID, int nId );
	void MenuMoveBuddy( UINT nCmdID, int nId );
	void MoveWindow( CRect rcClient, BOOL param2 );
	HWND GetSafeHwnd() const;
	void DestroyWindow();
	void SetInfoBtnCount( int nAuthCount );
	void __ResourceLoad();
	static BOOL MakeAboutMeSatusPopupMenu( CMenu* pMenuStatus );
	BOOL IsMobileOnline();
	void AddChatRoomList(CChatDlg* pChatDlg);
	void AddChatRoomList(const NE_MYROOM_DATA& myRoomData);
	void UpdateChatRoomList(CChatDlg* pChatDlg, BOOL bSort=FALSE);
	void RemoveChatRoomForTimeout();
	BOOL FindSingleChatDlg(LPCTSTR strUserID, int nRoomID);
	int GetInfoItemNoteItemCount();
	CRecentContacts* GetRecentContacts();
	void RemoveChatRoom(int nRoomID, BOOL bDeleteData = TRUE);
	void SetRecentChatDlg(int nRoomID, CChatDlg *pChatDlg);
    
	CBuddyTreeCtrl* GetFavoriteTreeCtrl();
	FavoriteView* GetFavoriteView() {return m_favoriteController.GetFavoriteView();};
	FavoriteController* GetFavoriteController();
	void ShowProfileWnd(const POINT &pt, CDuiString strID);

	void UpdateAllBuddyDisplayNames();
	void LoadAboutMeStatusPopup(CPoint pt);
	vector<CString> GetBookmarkVector();

	map<CDuiString, Node*>*	GetFavUsrIDNode(){return &m_mapFavUserIDNode;};
	void OnDragStart1();
	void SetSearchWndHeight(int nHeight);
	BOOL IsRecentChatSearchMode() {return m_bSearchRecentChat;};
	CString GetSearchWord() {return m_strSearchWord;};
	NE_NOTICE_DATA GetNoticeDataBySeq(unsigned long seq);
	void ResortBuddyInGroup(int nGroupID);
	void GetSelectedOrgItems(std::vector<Node*> &vecSelectedOrgUser);
	void ResortChatRoomList(vector <ChatRoomItem*> &vecChatItem);
	void UpdateAllChatRoomTime();
	EMENUTAB    GetCurrentTabSelect();
	void DoInfoItemVOC();
	void DoInfoItemSign();
	void DoInfoItemIN();
	void DoInfoItemSAM();
	void DoInfoItemMail();
	void DoInfoItemSurvey();
	void DoInfoItemNote();
	void DoInfoItemChatHistory();

	CString MakeHanatourLoginData(CString strLegacySystemName);

public:
	vector<CString> m_vecAllBuddy;
	CObList			m_listSmsPop;
private:
    LRESULT     _OnMsgSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT     _OnMsgMouseWheel(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT     _OnMsgSysKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT     _OnMsgKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT     _OnMsgCloseMainSearch(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT     _OnMsgRequestOrgnizationMember(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT     _OnMsgUserImageUpdated(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    

    LRESULT     _OnCommandMenuUserInfo(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT     _OnCommandMenuSendMemo(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT     _OnCommandMenuTreeSendMemo(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT     _OnCommandMenuChatHistory(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT     _OnCommandRangeUserIdList(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT     _OnCommandRangeUserIdTree(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT     _OnCommandMenuChat(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT     _OnCommandMenuCreateFavoriteGroup(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT     _OnCommandMenuSms(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
    LRESULT     _OnCommandMenuTreeSms(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
	CString StringToHex(char* pData);
	void OpenURLService(CString strURL);
private:
	vector<wstring>  m_vecRequsetStatusUsers;
	CDuiString		 m_strMyGroupID;
	Node*			 m_pRequestNode;
	CCriticalSection m_csChatSearch;
	CCriticalSection m_csNotifyAction;

    CNeMessengerDlg*    m_pMessengerMain;
	UINT m_uClipBoardFormat;
	CTreeTDropTarget m_DropTarget;
	vector<Node*> m_vecSelectItems;
	CChatSearchWnd	*m_pChatSearchWnd;
	CSmsSearchWnd   *m_pSmsSearchWnd;
	CRecentContacts	m_recentContacts;
	int bk_image_index_;
	FriendListItemInfo myself_info_;
	//std::vector<FriendListItemInfo> friends_;
	std::vector<OrganizationListItemInfo> m_vecOrgList;
	CDialogBuilder m_dlgBuilder;
	CWnd* wnd;
	CImageList*	m_pImgList;
	long refcount;
	CComPtr<IDataObject> pDragDataObj;

	CMainMenuControler m_mainMenuControler;
	CString m_strSearchWord;
	CSearchWnd *m_pSearchWnd;
	int			m_nSearchWndHeight;
	BOOL		m_bShowSearchWnd;
	BOOL		m_bSearchRecentChat;
	CCallHistoryDlg *m_pCallHistoryDlg;
	CAutoTextConfigDlg	m_AutoTextConfigDlg;
	bool m_bSearch;

	//image
	CWinThread*		m_pImageDownloadThread;
	CString			m_sServer; 
	CString			m_sObject; 
	CString			m_sFilename;
	CDuiString		m_strRequestImageID;
	INTERNET_PORT	m_nPort;
	DWORD			m_dwServiceType;
	HINTERNET		m_hInternetSession;
	HINTERNET		m_hHttpConnection;
	HINTERNET		m_hHttpFile;
	BOOL			m_bAbort;
	BOOL			m_bSafeToClose;
	CFile			m_FileToWrite;

	FavoriteController m_favoriteController;
	EDDTYPE				m_eDragDropType;
	Node* m_pCurSelNode;
	map<CDuiString, Node*>	m_mapOrgFileIDNode;
	multimap<CDuiString, Node*>	m_mapOrgUserIDNode;
	map<CDuiString, Node*>	m_mapFavUserIDNode;
	map<CDuiString, Node*>	m_mapSearchUserIDNode;
	map<CDuiString, Node*>	m_mapChatSearchUserIDNode;
	DWORD m_nUserAuth;
	GROUP_MEMU_LIST			m_GroupList;
	BOOL					m_bRequestORGGroup;
	
	friend class CBuddyTreeCtrl;
	friend class CRecentChatListManager;

	
	CBuddyTreeCtrl* m_pBuddyList;
	CRecentChatListManager* m_pChatListManager;
    CDuiOrgList*  m_pOrgList;


	CInfoBannerController  m_InfoBannerCtrller;

	//CBannerNoticeWnd*  m_pBannerNotice;
	unsigned long       m_rollingNoticeSeq;
	std::vector<NE_NOTICE_DATA> m_vecNoticeList;


	BOOL						m_bEnableNotice;
	BOOL						m_bEnableBanner;

	

	//CInfoItemWnd				m_wndInfoItemVOC;
	//CInfoItemWnd				m_wndInfoItemSign;
	//CInfoItemWnd				m_wndInfoItemIN;
	//CInfoItemWnd				m_wndInfoItemSAM;



	ePOPUP_TYPE					m_ePopupMenuType;
};


class ComputerExamineUI : public CContainerUI
{
public:
	ComputerExamineUI()
	{
		CDialogBuilder builder;
		CContainerUI* pComputerExamine = static_cast<CContainerUI*>(builder.Create(_T("skin.xml"), (UINT)0));
		if( pComputerExamine ) {
			this->Add(pComputerExamine);
		}
		else {
			this->RemoveAll();
			return;
		}
	}
};

class CDialogBuilderCallbackEx : public IDialogBuilderCallback
{
public:
	CDialogBuilderCallbackEx(MainFrame *pMainFrame)
	{
		m_pMainFrame = pMainFrame;
	}
	CControlUI* CreateControl(LPCTSTR pstrClass)
	{
		if( _tcscmp(pstrClass, _T("ComputerExamine")) == 0 ) 
			return new ComputerExamineUI;
		return m_pMainFrame->CreateControl(pstrClass);
	}
	MainFrame *m_pMainFrame;
};